* title CHANGE DIR procedure for Level 2 drivers
* (C) 1993 Malcolm Lear LDS V 1.00
*
* Syntax:
*       CD  Newpath.
*
*       Command          or               Result
*
*       data_use flp1_   cd flp1_         flp1_
*       cd n1            cd n1            flp1_n1_
*       cd n2            cd n2            flp1_n1_n2_
*       cd u             cd '..'          flp1_n1_
*       cd n3_n4         cd 'n3\n4'       flp1_n1_n3_n4_
*       cd u_n5          cd '..\n5'       flp1_n1_n3_n5_
*       cd u_u           cd '..\..'       flp1_n1_
*       cd n6_n7         cd 'n6\n7'       flp1_n1_n6_n7_
*       cd u_u_n8        cd '..\..\n8'    flp1_n1_n8_
*       cd _             cd '\'           flp1_
*
*       cd with no parameter prints data_use path
*
* Note: '/' can be used in place of '\'
*
* Synopsis:
*       Modifies the data_use and prog_use path.
*
* Errors:
*       not found:          non-existant path.
*       invalid parameter:  incorrect syntax.
*
*
sys_datd equ    $b0
sys_prgd equ    $ac
ut.wtext equ    $d0
err.ipar equ    -$f
sb.gtstr equ    $116
bv_rip   equ    $58
bv_ntbas equ    $18
bv_nlbas equ    $20
qa.resri equ    $11a
sb.inipr equ    $110
*
start
        move.w  sb.inipr,a0
        lea.l   define,a1
        jsr     (a0)
        rts
define
        dc.w    2
        dc.w    chg_dir-*
        dc.b    2,'CD'
        dc.w    chg_prg-*
        dc.b    3,'CDp'
        dc.w    0
        dc.w    0
        dc.w    0
*
str1
        dc.b    0,2,' ','['
str2
        dc.b    0,2,']',10
str3
        dc.b    0,1,10,0
        dc.w    0
prt_path
        moveq   #0,d0
        trap    #1
        movea.l a0,a3
        lea     mode_flag,a2
        tst.b   (a2)
        beq.s   cd_mde4
        movea.l sys_prgd(a3),a1          * print prog_use string only
        bra.s   prt_prgd
cd_mde4
        movea.l sys_datd(a3),a1
        movea.l sys_prgd(a3),a2
        moveq   #1,d4
        move.w  (a1),d2
        cmp.w   (a2),d2                  * compare string lengths
        bne.s   dif_path
cmp_path
        move.b  1(a1,d2.w),d0
        move.b  1(a2,d2.w),d1
        andi.b  #$df,d0
        andi.b  #$df,d1
        cmp.b   d0,d1
        bne.s   dif_path
        subi.w  #1,d2
        bne.s   cmp_path
prt_prgd
        moveq   #0,d4
dif_path
        suba.l  a0,a0
        movea.w ut.wtext,a2
        jsr     (a2)                     * print primary path ie:
        tst.b   d4                       * data_use string in cd mode or
        beq.s   prt_return               * prog_use string in cdp mode
        lea     str1,a1
        movea.w ut.wtext,a2
        jsr     (a2)                     * print '['
        movea.l sys_prgd(a3),a1
        movea.w ut.wtext,a2
        jsr     (a2)                     * print prog_use string
        lea     str2,a1
        movea.w ut.wtext,a2
        jsr     (a2)                     * print ']'
        moveq   #0,d0
        rts
prt_return
        lea     str3,a1
        movea.w ut.wtext,a2
        jsr     (a2)                     * print line feed
        moveq   #0,d0
*
cd_rts
        rts
chg_prg
        lea     mode_flag,a2
        move.b  #-1,(a2)
        bra.s   cdp_mde1
chg_dir
        lea     mode_flag,a2
        move.b  #0,(a2)
cdp_mde1
        moveq   #1*8,d0         * Check one parameter.
        sub.l   a5,d0
        add.l   a3,d0
        blt     err_ip_cd       * If not take error exit
        bgt     prt_path
        bsr.l   ut_stos         * get a string or name at (a1)
        bne.s   cd_rts          * ... oops
        move.l  a1,d1
        lea     str_store,a0
        move.l  a0,a1           * a1 = base of stored command
        moveq   #0,d3           * clean up d3
        move.w  (a6,d1.l),d3    * d3 = command string length
        cmpi.w  #$80,d3
        bgt     err_ip_cd       * string to long
        move.w  d3,(a0)         * move string length
        add.l   d3,d1           * d1 = index pointer to last character
        move.b  #'_',2(a0,d3.w) * put this here for 'u' operation
cmd_sv_lp
        move.b  1(a6,d1.l),1(a0,d3.w)
        subi.l  #1,d1
        dbra    d3,cmd_sv_lp
*
        move.l  a1,a2
        adda.l  #$80,a2
        moveq   #0,d0
        trap    #1
*                               * a0 = pointer to system variables
*                               * a1 = pointer to stored command string
*                               * a2 = pointer to new path string
        move.l  sys_datd(a0),a3 * a3 = pointer to data_use string
        move.l  sys_prgd(a0),a4 * a4 = pointer to prog_use string
        lea     mode_flag,a0
        tst.b   (a0)
        beq.s   cd_mde2
        move.l  a4,a3           * a3 = pointer to prog_use string
cd_mde2
        moveq   #0,d0
        move.w  (a3),d0         * d0 = old path string length
        move.w  d0,(a2)         * move string length
use_sv_lp
        move.b  1(a3,d0.w),1(a2,d0.w) * move string
        dbra    d0,use_sv_lp
*
        move.w  (a1),d1         * d1 = command string length
        move.w  (a2),d0         * d0 = old path string length

*
        move.l  2(a1),d2
        cmpi.b  #$31,d2
        blt.s   not_root
        cmpi.b  #$38,d2
        bgt.s   not_root
        andi.l  #$dfdfdf00,d2
        addi.b  #'_',d2
        cmpi.l  #'FLP_',d2
        beq.s   root2
        cmpi.l  #'RAM_',d2
        beq.s   root2
        cmpi.l  #'WIN_',d2
        beq.s   root2
        cmpi.l  #'DEV_',d2
        beq.s   root2
        cmpi.l  #'MDV_',d2
        beq.s   root2
        bra.s   not_root
root2
        moveq   #0,d0           * new path string length = 0
*
not_root
        moveq   #0,d2           * d2 = command parser offset
*
cd_lp
        addi.w  #1,d2           * increment parser
        cmp.w   (a1),d2         * compare parser with string length
        bgt     cd_rts_ok       * end of command
        cmpi.b  #'_',1(a1,d2.w)
        beq     syntax
        cmpi.b  #'/',1(a1,d2.w)
        beq     syntax
        cmpi.b  #'\',1(a1,d2.w)
        beq     syntax
        cmpi.b  #'.',1(a1,d2.w)
        beq.s   dir_up
        cmpi.b  #'u',1(a1,d2.w)
        beq.s   dir_up2
        cmpi.b  #'U',1(a1,d2.w)
        beq.s   dir_up2
dir_down
        addi.w  #1,d0
        move.b  1(a1,d2.w),1(a2,d0.w) * move string
        addi.w  #1,d2           * increment parser
        cmp.w   (a1),d2         * compare parser with string length
        bgt.s   parser_end      * end of command
        cmpi.b  #'_',1(a1,d2.w)
        beq.s   down_end
        cmpi.b  #'/',1(a1,d2.w)
        beq.s   down_end
        cmpi.b  #'_',1(a1,d2.w)
        beq.s   down_end
        bra.s   dir_down
down_end
        addi.w  #1,d0
        move.b  #'_',1(a2,d0.w) * terminate with '_'
        move.w  d0,(a2)         * change new path string length
        bra.s   cd_lp
parser_end
        addi.w  #1,d0
        move.b  #'_',1(a2,d0.w) * terminate with '_'
        move.w  d0,(a2)         * change new path string length
        bra.s   cd_rts_ok
dir_up2
        cmpi.b  #'_',2(a1,d2.w)
        beq.s   up_lp
        cmpi.b  #'/',2(a1,d2.w)
        beq.s   up_lp
        cmpi.b  #'\',2(a1,d2.w)
        beq.s   up_lp           * single 'u'
        bra     dir_down        * normal directory name
dir_up
        addi.w  #1,d2
        cmp.w   (a1),d2         * compare parser with string length
        bgt.s   cd_rts_ok       * end of command
        cmpi.b  #'.',1(a1,d2.w)
        bne     cd_lp           * only single '.'
up_lp
        cmpi.w  #5,d0           * check for root
        beq     err_ip_cd
        subi.w  #1,d0           * shorten new path string
        cmpi.b  #'_',1(a2,d0.w) * check for end
        beq.s   up_end
        bra.s   up_lp
up_end
        move.w  d0,(a2)         * change new path string length
        addi.w  #1,d2           * compensate for extra '.'
        cmp.w   (a1),d2         * compare parser with string length
        bgt.s   cd_rts_ok       * end of command
        bra     cd_lp

syntax
        cmpi.w  #1,d2
        bne.s   err_ip_cd
root
        move.w  #5,d0           * change new path to device only
        move.w  d0,(a2)
        bra     cd_lp
cd_rts_ok
        moveq   #0,d2
        move.w  (a2),d2         * d2 = new path string length
        cmpi.w  #$21,d2         * check for maximum size
        bgt.s   err_ip_cd
*
        movea.l a2,a0           * a0 = pointer to new path string
        moveq   #1,d0           * trap key for ioa.open
        moveq   #-1,d1          * job ID this task will own the channel
        moveq   #1,d3           * try to open_in
        trap    #2              * open channel
*                               * a0 = channel ID
        tst.l   d0              * check for error
        bne.s   err_cd          * if error then channel not opened
        moveq   #2,d0           * trap key for ioa.clos
        trap    #2              * close channel
*
        lea     mode_flag,a0
        tst.b   (a0)
        beq.s   cd_mde3
        move.w  d2,d0           * d0 = new path string length
        move.w  d0,(a3)         * move string length
        bra.s   use_ld_lp       * change prog_use path
*
cd_mde3
        move.w  d2,d0           * d0 = new path string length
        move.w  (a3),d2         * data_use string length
        move.w  d0,(a3)         * move string length
        cmp.w   (a4),d2         * compare data_use , prog_use string length
        bne.s   use_ld_lp       * change data_use path
diff_loop
        move.b  1(a3,d2.w),d3
        move.b  1(a4,d2.w),d4
        andi.b  #$df,d3
        andi.b  #$df,d4
        cmp.b   d3,d4
        bne.s   use_ld_lp      * change data_use path
        subi.w  #1,d2
        beq.s   same_path      * prog_use and data_use are the same
        bra.s   diff_loop
same_path
        move.w  d0,d1
prog_ld_lp
        move.b  1(a2,d1.w),1(a4,d1.w) * move string
        dbra    d1,prog_ld_lp
use_ld_lp
        move.b  1(a2,d0.w),1(a3,d0.w) * move string
        dbra    d0,use_ld_lp
        moveq   #0,d0
        rts

err_ip_cd
        moveq   #err.ipar,d0
err_cd
        rts
str_store
        ds.b    $100
mode_flag
        dc.w    0

* Get a string on the stack   V0.2    1985  Tony Tebby   QJUMP
* Modified to accept numbers and expressions (C) 1986 David Oliver CST V 4.00
*
ut_stos
        tst.w   2(a6,a3.l)      * Get name of parameter.                ** 4.00 **
*                               * If none, it must be an expression...  ** 4.00 **
        bmi.s   ut_gtstr        * ... so convert the value to a string.  ** 4.00 **

        moveq   #$0f,d0         * extract type of parameter.
        and.b   1(a6,a3.l),d0
        subq.b  #1,d0           is it a string?
        bne.s   ut_gtnam        ... no, get the name instead
ut_gtstr
        move.l  a5,-(sp)        ... yes, save the top pointer
        lea     8(a3),a5        get just one string
        move.w  sb.gtstr,a2
        jsr     (a2)
        move.l  (sp)+,a5        restore top pointer
        bne.s   utils_rts
        moveq   #3,d1           get total length of string
        add.w   (a6,a1.l),d1
        bclr    #0,d1
        add.l   d1,bv_rip(a6)   and reset ri stack pointer
        bra.s   utils_ok

ut_gtnam
        moveq   #err.ipar,d0    assume bad parameter
        moveq   #0,d1
        move.w  2(a6,a3.l),d1   get the pointer to the real entry
        bmi.s   utils_rts       ... expression is no good
        lsl.l   #3,d1           in multiples of 8 bytes
        add.l   bv_ntbas(a6),d1
ut_ntnam
        moveq   #0,d6
        move.w  2(a6,d1.l),d6   thus the pointer to the name
        add.l   bv_nlbas(a6),d6
        moveq   #0,d1           get the length of the name as a long word
        move.b  (a6,d6.l),d1
        addq.l  #1,d1           rounded up
        bclr    #0,d1
        move.w  d1,d4           and save it
        addq.l  #2,d1           space required is +2 bytes
        move.w  qa.resri,a2     on ri stack
        jsr     (a2)
        move.l  bv_rip(a6),a1
*
        add.w   d4,d6           move to end of string (ish)
ut_nam_loop
        subq.l  #1,a1           and copy one byte at a time
        move.b  (a6,d6.l),(a6,a1.l)
        subq.l  #1,d6
        dbra    d4,ut_nam_loop  including the (byte) name length
        subq.l  #1,a1           put a zero on to make it a word
        clr.b   (a6,a1.l)
utils_ok
        moveq   #0,d0
utils_rts
        rts
        end
